/*
DTWSelectionPlotter.java -- DTREND PROJECT
Author: Tero Rontti
Version: 0.1
Revision date: 23.2.2002
Creation date: 10.2.2002


DTREND PROJECT
Project manager: Juha Ylipekkala
Project group: Timo Ahonen, Tero Rontti, Juha Ylipekkala

-------------------------------------------------------------------------------
REVISION HISTORY

Version 0.00
Initial version, not working.
Author: Tero Rontti
Date: 23.2.2002
Known bugs/problems:
 * Lack of comments
 * No mouse functionality

Version 0.1
Working version

*/

package org.dtrend;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/** DataSelector class
 * @author Tero Rontti
 * @version 0.1
 */
public class DTWDataSelector extends JDialog {
    DTWData Data;
    DTWFileIO FileIO;
    int lines;

    JPanel jPanel1 = new JPanel( );
    JPanel jPanel2 = new JPanel( );
    BorderLayout borderLayout1 = new BorderLayout();
    GridLayout gridLayout1 = new GridLayout();
    JLabel jLabel3 = new JLabel();
    JTextField RecordNumber = new JTextField();
    JButton jButton1 = new JButton();
    JButton jButton2 = new JButton();
    JButton jButton3 = new JButton();
    DTWSelectionPlotter Plotter;
    JPanel jPanel3 = new JPanel();
    JLabel jLabel1 = new JLabel();
    JTextField jTextField2 = new JTextField();
    JLabel jLabel2 = new JLabel();
    JTextField jTextField3 = new JTextField();
    FlowLayout flowLayout1 = new FlowLayout();
    float[] current;
    int selectionStart=0;
    int selectionEnd=0;
    String currName;

    public DTWDataSelector( Frame owner, DTWData DataObject, DTWFileIO FileIOObject, int numlines ) {
        super( owner, "Data selector", true );
        this.setSize( new Dimension( 600, 380 ));
		try {
			jbInit();
		}
		catch(Exception e) {
			e.printStackTrace();
		}
		
        current = null;
        Data = DataObject;
        FileIO = FileIOObject;
        lines = numlines;
		
        jLabel3.setText("Record to show: (1 - " + new Integer(lines).toString() +")" );
    }
	
    private void jbInit() throws Exception {
        jPanel1.setMinimumSize(new Dimension( 200, 400 ));
        jPanel3.setMinimumSize(new Dimension( 400, 100 ));
        jPanel2.setMinimumSize(new Dimension( 400, 300 ));
        Plotter = new DTWSelectionPlotter( 400, 300 );
		jPanel3.setLayout(flowLayout1);
		this.getContentPane().setLayout(borderLayout1);
		jPanel1.setLayout(gridLayout1);
		jLabel3.setToolTipText("");
		RecordNumber.setMaximumSize(new Dimension(100, 27));
		gridLayout1.setColumns(1);
		gridLayout1.setRows(0);
		jButton1.setText("Save as template");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jButton1_actionPerformed(e);
				}
			});
		jButton2.setText("Save as observation");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jButton2_actionPerformed(e);
				}
			});
		jButton3.setText("Close selection view");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jButton3_actionPerformed(e);
				}
			});
		
		jLabel1.setText("First selected");
		jLabel2.setText("Last selected");
		jTextField2.setMinimumSize(new Dimension(100, 27));
		jTextField2.setPreferredSize(new Dimension(100, 27));
        jTextField2.addFocusListener( new FocusListener(){
				public void focusLost(FocusEvent e){
					jTextField2_update();
				}
				public void focusGained(FocusEvent e){
				}
			});
		
		jTextField3.setMinimumSize(new Dimension(100, 27));
		jTextField3.setPreferredSize(new Dimension(100, 27));
        jTextField3.addFocusListener( new FocusListener(){
				public void focusLost(FocusEvent e){
					jTextField3_update();
				}
				public void focusGained(FocusEvent e){
				}
			});
		
        RecordNumber.getDocument().addDocumentListener(new javax.swing.event.DocumentListener(){
				public void changedUpdate(javax.swing.event.DocumentEvent e){
					changeRecord();
				}
				public void insertUpdate(javax.swing.event.DocumentEvent e){
					changeRecord();
				}
				public void removeUpdate(javax.swing.event.DocumentEvent e){
					changeRecord();
				}
			});
		
		flowLayout1.setAlignment(FlowLayout.RIGHT);
        this.getContentPane().add(jPanel1,  BorderLayout.WEST);
        this.getContentPane().add(jPanel2, BorderLayout.CENTER);
		jPanel1.add(jLabel3, null);
        jPanel1.add(RecordNumber, null);
		jPanel1.add(jButton1, null);
		jPanel1.add(jButton2, null);
		jPanel1.add(jButton3, null);

        jPanel2.add(Plotter);

		jPanel3.add(jLabel1);
        jPanel3.add(jTextField2);
		jPanel3.add(jLabel2);
        jPanel3.add(jTextField3);
		this.getContentPane().add(jPanel3,  BorderLayout.SOUTH);

    }
	
    void jButton1_actionPerformed(ActionEvent e) {
        DTWDataVector templ = new DTWDataVector();
        DTWDataVector[] temp = new DTWDataVector[1];
		if( current == null ){
			JOptionPane.showMessageDialog( this, "No selection to save." );
			return;
		}
		
		do{
			currName = JOptionPane.showInputDialog(this, new String("Enter name for template"));
			if( currName != null )
				if( currName.length() == 0 )
					JOptionPane.showMessageDialog(this, "No name entered");
		}while(currName.length() == 0);

        templ.setName( currName );
        float[] val = new float[selectionEnd-selectionStart+1];
        System.arraycopy(current, selectionStart, val, 0, val.length);
        templ.setValues(val);
        temp[0] = templ;
        Data.addTemplates(temp);
		currName = "";
    }

    void jButton2_actionPerformed(ActionEvent e) {
        DTWDataVector obs = new DTWDataVector();
		if( current == null ){
			JOptionPane.showMessageDialog( this, "No selection to save." );
			return;
		}
		
		do{
			currName = JOptionPane.showInputDialog(this, new String("Enter name for observation"));
			if( currName != null )
				if( currName.length() == 0 )
					JOptionPane.showMessageDialog(this, "No name entered");
		}while(currName.length() == 0);

        obs.setName( currName );
        float[] val = new float[selectionEnd-selectionStart+1];
        System.arraycopy(current, selectionStart, val, 0, val.length);
        obs.setValues(val);
        Data.setObservation(obs);
		currName = "";
    }

    void jButton3_actionPerformed(ActionEvent e) {
        this.dispose();
    }

    void jTextField2_update() {
        int temp;
        temp = selectionStart;
        try{
            selectionStart = Integer.parseInt(jTextField2.getText());
        }catch( Exception ex ){
            selectionStart = temp;
        }
        if( selectionStart < 0 ){
            selectionStart = 0;
        }
        if( selectionStart > current.length-3 ){
            selectionStart = current.length-3;
        }

        if( selectionEnd < selectionStart+2 ){
            selectionEnd = selectionStart+2;
        }
        jTextField2.setText(new Integer(selectionStart).toString());
        jTextField3.setText(new Integer(selectionEnd).toString());
        Plotter.setSelection( selectionStart, selectionEnd );
        Plotter.drawPlotting();
    }

    void jTextField3_update() {
        int temp;
        temp = selectionEnd;
        try{
            selectionEnd = Integer.parseInt(jTextField3.getText());
        }catch( Exception ex ){
            selectionEnd = temp;
        }
        if( selectionEnd < 2 )
            selectionEnd = 2;
        if( selectionEnd > current.length-1 )
            selectionEnd = current.length-1;
        if( selectionEnd < selectionStart+2 )
            selectionEnd = selectionStart+2;

        jTextField2.setText(new Integer(selectionStart).toString());
        jTextField3.setText(new Integer(selectionEnd).toString());
        Plotter.setSelection( selectionStart, selectionEnd );
        Plotter.drawPlotting();
    }

    void plot( float[] curr, String currName ){
        DTWDataVector d = new DTWDataVector();
        d.setName(currName);
        d.setValues(curr);
        Plotter.setValues(d);
    }

    void changeRecord( ){
        int num;
        try{
            num = Integer.parseInt( RecordNumber.getText());
            if( num >= 0 && num <= lines ){
                current = FileIO.loadRecord(num);
                selectionStart = 0;
                selectionEnd = current.length-1;
                Plotter.setSelection(selectionStart, selectionEnd );
                plot(current, num + "/" + lines);
                jTextField2.setText("0");
                jTextField3.setText(Integer.toString(selectionEnd));

            }
            else{
                current = null;
                plot( current, "Error loading record" );
            }
        }
        catch( Exception ex ){
            current = null;
			if( RecordNumber.getText().length() != 0 )
			   plot( current, "Error loading record" );
			else
				plot( current, "" );
        }

    }
}
