/*
DTWDataVector.java -- DTREND PROJECT
Author: Tero Rontti
Version: 0.1
Revision date: 23.2.2002
Creation date: 10.2.2002


DTREND PROJECT
Project manager: Juha Ylipekkala
Project group: Timo Ahonen, Tero Rontti, Juha Ylipekkala

-------------------------------------------------------------------------------
REVISION HISTORY

Version 0.1
Initial working version
Author: Tero Rontti
Date: 23.2.2002
Known bugs/problems:
*/

package org.dtrend;

/** A class containing name and values for a data vector
 * (A template or an observation)
 * @author Tero Rontti
 * @version 0.1
 */
public class DTWDataVector{
    private String name;
    private float[] values;

    /** Class constructor. */
    public DTWDataVector(){
    } /** DTWDataVector() ends */

    /** Set the object name
     * @param newName New name
     */
    public void setName( String newName ){
	name = newName;
    } /** setName() ends */

    /** Return the object name.
     * @return Name
     */
    public String getName( ){
	return name;
    } /** getName() ends */

    /** Copy values from newValues to values array.
     * @param newValues The values to be copied.
     */
    public void setValues( float[] newValues ){
        if( newValues != null ){
    	    values = new float[newValues.length];
	    System.arraycopy( newValues, 0, values, 0, newValues.length );
        }
        else{
            values = null;
        }
    } /** setValues() ends */

    /** Get the values array
     * @return Values array.
     */
    public float[] getValues( ){
	return values;
    } /** getValues() ends */
}
