//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop
#include <iostream>
#include <fstream>
#include <vector>
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"


#define PI 3.14159265359

using namespace std;

DTADDTEMPLATE DTAddTemplate;
DTDELTEMPLATE DTDelTemplate;
DTCOMPAREONE DTCompareOne;
DTCOMPAREALL DTCompareAll;
DTGETTEMPLATE DTGetTemplate;
HINSTANCE DtwDll;

TForm1 *Form1;

DTWOneResult* result;
DTWParameters params;
DTWAllResultsElement* allresults;
int * numresults=NULL;
int iter;

float templ1[]={1.1,2.2,3.3,2.2,1.1};
float obs1[]={2.2,4.4,2.2};


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
        DtwDll=LoadLibrary("DtwLib");
        if (DtwDll != NULL)
        {
        DTAddTemplate=(DTADDTEMPLATE)GetProcAddress(DtwDll,"DTAddTemplate");
        DTDelTemplate=(DTDELTEMPLATE)GetProcAddress(DtwDll,"DTDelTemplate");
        DTCompareOne=(DTCOMPAREONE)GetProcAddress(DtwDll,"DTCompareOne");
        DTCompareAll=(DTCOMPAREALL)GetProcAddress(DtwDll,"DTCompareAll");
        DTGetTemplate=(DTGETTEMPLATE)GetProcAddress(DtwDll,"DTGetTemplate");
        Label1->Caption="Loaded";
        }
        if (DTAddTemplate==NULL) Label1->Caption="ERROR";
        
        params.dmetrics=0;
        params.wwidth=999;
        params.seoffset=8;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        int k=DTAddTemplate(templ1,sizeof(templ1)/sizeof(float));
        Label2->Caption=k;
        Form1->Repaint();
        result=DTCompareOne(obs1,sizeof(obs1)/sizeof(float),params,k);
        Label1->Caption=result->dtwDistance;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
     float* temppi;
     int len,j,k,l;

     for(l=0;l<100;l++)
     {


     delete[] temppi;
                                                                                                                  len=random(100)+10;
     Label2->Caption=len;
     temppi=new float[len];
     for(j=0;j<len;j++)
        temppi[j]=((float)random(200))/10;
     k=DTAddTemplate(temppi,len);
     len=random(100)+10;
     Label3->Caption=len;
     temppi=new float[len];
     for(j=0;j<len;j++)
        temppi[j]=((float)random(200))/10;

     result=DTCompareOne(temppi,len,params,k);
     for(j=0;j<result->pathLen;j++)
        delete[] result->warpingPath[j];

     delete[] result->warpingPath;
     Label1->Caption=result->dtwDistance;

     delete[] temppi;
     DTDelTemplate(k);

     Form1->Repaint();
     }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
        FreeLibrary(DtwDll);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
     float* temppi;
     int len,j,k;

     len=random(100)+10;
     temppi=new float[len];
     for(j=0;j<len;j++)
        temppi[j]=((float)random(200))/10;
     k=DTAddTemplate(temppi,len);

     delete[] temppi;
     Label4->Caption=k;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button4Click(TObject *Sender)
{
        float* temppi;
        int len,j,k;

        len=random(100)+10;
        temppi=new float[len];
        for(j=0;j<len;j++)
        temppi[j]=((float)random(200))/10;

        if (numresults==NULL) numresults=new int;
        allresults = DTCompareAll(temppi,len,params,numresults);
        Label5->Caption=(*numresults);
        iter=0;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)
{
        if(iter<*numresults)
        {
                Label6->Caption=allresults[iter].tIndex;
                Label7->Caption=allresults[iter].dtwDistance;
                iter++;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)
{
        float** templates;
        int *lengths,*indexes;
        int nSeq,i,j,len,num=100;
        float* ttemplate;
        bool ok;
        ofstream out("output.txt",ios_base::out);

        lengths=new int[num];
        indexes=new int[num];
        templates=new float*[num];
        for(int i=0;i<num;i++) {
                len=random(297)+3;
                lengths[i]=len;
                templates[i]=new float[len];
                for(j=0;j<len;j++)
                        templates[i][j]=((float)random(2000))/10-100;
                indexes[i]=DTAddTemplate(templates[i],len);

                out << "Stored template number " << indexes[i] << endl;

                for(j=0;j<len;j++)
                  out << templates[i][j] << " ";
                out << endl;
        }

        for(int i=0;i<num;i++) {
                ttemplate=DTGetTemplate(indexes[i],&nSeq);
                ok=true;
                if(nSeq==lengths[i])
                {
                  for(j=0;j<lengths[i];j++)
                    if(ttemplate[j]!=templates[i][j])
                        ok=false;
                } else
                {
                        ok=false;
                }

                out << "Loaded template number " << indexes[i];

                if (ok)
                        out << " ok." << endl;
                else
                        out << "NOT OK!!!" << endl;

                for(j=0;j<lengths[i];j++)
                  out << ttemplate[j] << " ";
                out << endl;
        }

        out.close();



}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)
{
        float** templates;
        int *lengths,*indexes;
        int nSeq,a,i,j,len,num=10,numa=10,numd=5;
        float* ttemplate;
        bool ok;
        ofstream out("output.txt",ios_base::out);

        lengths=new int[num*numa];
        indexes=new int[num*numa];
        templates=new float*[num*numa];

        for(int a=0;a<numa;a++) {

        for(int i=0;i<num;i++) {
                len=random(297)+3;
                lengths[a*num+i]=len;
                templates[a*num+i]=new float[len];
                for(j=0;j<len;j++)
                        templates[a*num+i][j]=((float)random(2000))/10-100;
                indexes[a*num+i]=DTAddTemplate(templates[a*num+i],len);

                out << "Stored template number " << indexes[a*num+i] << endl;

                for(j=0;j<len;j++)
                  out << templates[a*num+i][j] << " ";
                out << endl;
        }

        for(int i=0;i<numd;i++) {
                do
                        j=random((a+1)*num);
                while(indexes[j]==-1);
                DTDelTemplate(indexes[j]);
                out << "Deleted template number" << indexes[j] << endl;
                indexes[j]=-1;  
        }
        }

        for(int i=0;i<numa*num;i++) {
                if(indexes[i]!=-1)
                {
                ttemplate=DTGetTemplate(indexes[i],&nSeq);
                ok=true;
                if(nSeq==lengths[i])
                {
                  for(j=0;j<lengths[i];j++)
                    if(ttemplate[j]!=templates[i][j])
                        ok=false;
                } else
                {
                        ok=false;
                }

                out << "Loaded template number " << indexes[i];

                if (ok)
                        out << " ok." << endl;
                else
                        out << "NOT OK!!!" << endl;

                for(j=0;j<lengths[i];j++)
                  out << ttemplate[j] << " ";
                out << endl;
                }
        }

        out.close();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)
{
        float mytemplate[]={2.2,4.5,3.3,9.9,1.1};
        float myobservation[]={1.2,3.5,2.2,7.7,4.4};
        DTWOneResult* myresult;
        int i,j,k;

        i=DTAddTemplate(mytemplate,5);

        params.dmetrics=0;
        params.wwidth=INT_MAX;
        params.seoffset=0;

        myresult=DTCompareOne(myobservation,5,params,i);

        ofstream out("output.txt",ios_base::out);
        out << "Total cost: " << myresult->dtwDistance << endl;
        out << "Warping path" << endl;
        for(i=0;i<myresult->pathLen;i++)
                out << myresult->warpingPath[i][0] << "," << myresult->warpingPath[i][1] << endl;

        out.close();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)
{
        float* mytemplate;
        float* myobservation,*juupajoo;
        float temppi;
        DTWOneResult* myresult;
        int i,j,k;
        vector<float> obs;

        ofstream out("output.txt",ios_base::out);


        mytemplate=new float[30];
        for(j=0;j<30;j++) {
                temppi=((float)random(2000))/10-100;
                mytemplate[j]=temppi;
                i=random(3)+1;
                for(k=0;k<i;k++)
                  obs.push_back(temppi);
        }

        myobservation=new float[ obs.size() ];
        for(j=0;j<obs.size();j++)
          myobservation[j]=obs[j];

        juupajoo=myobservation;
        myobservation=mytemplate;
        mytemplate=juupajoo;

        i=DTAddTemplate(mytemplate,obs.size());

        out << "Stored template number " << i << endl;

        for(j=0;j<obs.size();j++)
                  out << mytemplate[j] << " ";
        out << endl;

         out << "Observation:" << endl;
         for(j=0;j<30;j++)
                  out << myobservation[j] << " ";
        out << endl;

        params.dmetrics=0;
        params.wwidth=INT_MAX;
        params.seoffset=0;

        myresult=DTCompareOne(myobservation,30,params,i);


        out << "Total cost: " << myresult->dtwDistance << endl;
        out << "Warping path" << endl;
        for(i=0;i<myresult->pathLen;i++)
                out << myresult->warpingPath[i][0] << "," << myresult->warpingPath[i][1] << endl;

        out.close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)
{
        int laskuri;
        float* mytemplate;
        float* myobservation;
        float temppi;
        DTWOneResult* myresult;
        int i,j,k;

        ofstream out("output.txt",ios_base::out);


        mytemplate=new float[60];
        myobservation=new float[60];
        for(j=0;j<60;j++) {
                mytemplate[j]=((float)random(2000))/10-100;
                myobservation[j]=((float)random(2000))/10-100;
        }

        i=DTAddTemplate(mytemplate,60);

        out << "Stored template number " << i << endl;

        for(j=0;j<60;j++)
                  out << mytemplate[j] << " ";
        out << endl;

         out << "Observation:" << endl;
         for(j=0;j<60;j++)
                  out << myobservation[j] << " ";
        out << endl;

        params.dmetrics=0;
        params.wwidth=5;
        params.seoffset=0;

        myresult=DTCompareOne(myobservation,60,params,i);


        out << "Total cost: " << myresult->dtwDistance << endl;
        out << "Warping path" << endl;
        for(i=0;i<myresult->pathLen;i++)
        {
                if(abs(myresult->warpingPath[i][0]-myresult->warpingPath[i][1])<5 )
                    out << myresult->warpingPath[i][0] << "," << myresult->warpingPath[i][1] << "ok" << endl;
                else if (myresult->warpingPath[i][0]-myresult->warpingPath[i][1]==5)
                    out << myresult->warpingPath[i][0] << "," << myresult->warpingPath[i][1] << "ok, lower limit" << endl;
                else if (myresult->warpingPath[i][1]-myresult->warpingPath[i][0]==5)
                    out << myresult->warpingPath[i][0] << "," << myresult->warpingPath[i][1] << "ok, upper limit" << endl;
                else
                    out << myresult->warpingPath[i][0] << "," << myresult->warpingPath[i][1] << "NOT OK!" << endl;
        }
        out.close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)
{
        int laskuri;
        float* mytemplate;
        float* myobservation;
        float temppi;
        DTWOneResult* myresult;
        int i,j,k;

        ofstream out("output.txt",ios_base::out);

        for(laskuri=0;laskuri<300;laskuri++)
        {
        out << "Test #" << laskuri << endl;

        mytemplate=new float[20];
        myobservation=new float[20];
        for(j=0;j<20;j++) {
                mytemplate[j]=((float)random(2000))/10-100;
                myobservation[j]=((float)random(2000))/10-100;
        }

        i=DTAddTemplate(mytemplate,20);

        out << "Stored template number " << i << endl;

        for(j=0;j<20;j++)
                  out << mytemplate[j] << " ";
        out << endl;

         out << "Observation:" << endl;
         for(j=0;j<20;j++)
                  out << myobservation[j] << " ";
        out << endl;

        params.dmetrics=0;
        params.wwidth=INT_MAX;
        params.seoffset=4;

        myresult=DTCompareOne(myobservation,20,params,i);

        out << "Total cost: " << myresult->dtwDistance << endl;
        out << "Start point: (" << myresult->warpingPath[0][0] << "," << myresult->warpingPath[0][1] << ")" << endl;
        out << "End point: (" << myresult->warpingPath[myresult->pathLen-1][0] << "," << myresult->warpingPath[myresult->pathLen-1][1] << ")" << endl;

        out << endl;
        }
        out.close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)
{
        float mytemplate[]={4.4,5.5,7.3,11.8,5.5,4.3,2.7,3.3};
        float myobservation[]={1.1,2.2,4.4,7.7,7.7,4.4,2.2,1.1};
        DTWOneResult* myresult;
        int i,j,k;

        i=DTAddTemplate(mytemplate,8);

        params.dmetrics=1;
        params.wwidth=INT_MAX;
        params.seoffset=0;

        myresult=DTCompareOne(myobservation,8,params,i);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button13Click(TObject *Sender)
{
        float** templates;
        float* mytemplate, *myobservation;
        vector<float> obs;
        int *lengths,*indexes;
        int nSeq,a,i,j,k,len,num=10,numa=10,numd=5,numresults;
        float* ttemplate;
        bool ok;
        float temppi;
        ofstream out("output.txt",ios_base::out);
        DTWAllResultsElement* myresults;
        lengths=new int[num*numa];
        indexes=new int[num*numa];
        templates=new float*[num*numa];

        for(int a=0;a<numa;a++) {

        for(int i=0;i<num;i++) {
                len=random(297)+3;
                lengths[a*num+i]=len;
                templates[a*num+i]=new float[len];
                for(j=0;j<len;j++)
                        templates[a*num+i][j]=((float)random(2000))/10-100;
                indexes[a*num+i]=DTAddTemplate(templates[a*num+i],len);

                out << "Stored template number " << indexes[a*num+i] << endl;

                for(j=0;j<len;j++)
                  out << templates[a*num+i][j] << " ";
                out << endl;
        }

        for(int i=0;i<numd;i++) {
                do
                        j=random((a+1)*num);
                while(indexes[j]==-1);
                DTDelTemplate(indexes[j]);
                out << "Deleted template number" << indexes[j] << endl;
                indexes[j]=-1;
        }
        }

        mytemplate=new float[30];
        for(j=0;j<30;j++) {
                temppi=((float)random(2000))/10-100;
                mytemplate[j]=temppi;
                i=random(3)+1;
                for(k=0;k<i;k++)
                  obs.push_back(temppi);
        }

        myobservation=new float[ obs.size() ];
        for(j=0;j<obs.size();j++)
          myobservation[j]=obs[j];

        i=DTAddTemplate(mytemplate,30);

        out << "Stored template number " << i << endl;

        for(j=0;j<30;j++)
                  out << mytemplate[j] << " ";
        out << endl;

        out << "Observation:" << endl;
        for(j=0;j<obs.size();j++)
                  out << myobservation[j] << " ";
        out << endl;

        params.dmetrics=1;
        params.wwidth=INT_MAX;
        params.seoffset=0;

        Label7->Caption=DTCompareOne(myobservation,obs.size(),params,100)->dtwDistance;

        myresults=DTCompareAll(myobservation,obs.size(),params,&numresults);

        out << endl << "Number of results: " << numresults << endl;

        for(j=0;j<numresults;j++)
         out << "Template number " << myresults[j].tIndex << ", cost: " << myresults[j].dtwDistance << endl;

        out.close();


}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button14Click(TObject *Sender)
{
        int laskuri;
        float* mytemplate;
        float* myobservation;
        float temppi;
        DTWOneResult* myresult;
        int i,j,k;

        ofstream out("output.txt",ios_base::out);

        for(laskuri=0;laskuri<300;laskuri++)
        {
        out << "Test #" << laskuri << endl;

        mytemplate=new float[20];
        myobservation=new float[20];
        for(j=0;j<20;j++) {
                mytemplate[j]=((float)random(2000))/10-100;
                myobservation[j]=((float)random(2000))/10-100;
        }

        i=DTAddTemplate(mytemplate,20);

        out << "Stored template number " << i << endl;

        for(j=0;j<20;j++)
                  out << mytemplate[j] << " ";
        out << endl;

         out << "Observation:" << endl;
         for(j=0;j<20;j++)
                  out << myobservation[j] << " ";
        out << endl;

        params.dmetrics=0;
        params.wwidth=3;
        params.seoffset=5;

        myresult=DTCompareOne(myobservation,20,params,i);

        out << "Total cost: " << myresult->dtwDistance << endl;
        out << "Start point: (" << myresult->warpingPath[0][0] << "," << myresult->warpingPath[0][1] << ")" << endl;
        out << "End point: (" << myresult->warpingPath[myresult->pathLen-1][0] << "," << myresult->warpingPath[myresult->pathLen-1][1] << ")" << endl;

        out << endl;
        }
        out.close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button15Click(TObject *Sender)
{
       int i;

       ofstream obs("obs.txt",ios_base::out);
       ofstream temp("temp.txt",ios_base::out);

       temp << "Sine wave" << endl;

       for(i=0;i<60;i++)
        temp << sin((double)(i*2*PI/59)) << " ";

       temp << endl;
       temp << "Square wave" << endl;
       for(i=0;i<30;i++)
        temp << "1 ";
       for(i=0;i<30;i++)
        temp << "-1 ";
       temp << endl;

       temp << "Triangle wave" << endl;
       for(i=0;i<15;i++)
        temp << (double)(i/14.0) << " ";

       for(i=1;i<=30;i++)
        temp << (double)(1.0-i/15.0) << " ";

        for(i=1;i<=15;i++)
         temp << (double)(-1.0+i/15.0) << " ";

       obs << "My observation" << endl;

       obs << "0 0 0 0 0 ";

       for(i=1;i<=10;i++)
        obs << sin((double)(i*PI/10)) << " ";

        for(i=1;i<=45;i++)
        obs << sin((double)(i*PI/45+PI)) << " ";

       obs.close();
       temp.close();
}
//---------------------------------------------------------------------------

